#include <iostream>
#include <cmath>

#include "C:\progra~1\croot\croot.h"

#define ndat 5

double  x[ndat]={0.246,0.295,0.339,0.376,0.423};
double  y[ndat]={1.010,1.195,1.372,1.552,1.714};
double ex[ndat]={0.008,0.008,0.008,0.008,0.008};
double ey[ndat]={0.022,0.029,0.021,0.024,0.025};


// Funzione di Fit
double xfun(double x, int npar, double *par){
  double val;
  val = x*par[1]+par[0];
  return val;

}

//.. sua derivata...
double xder(double x, int npar, double *par){
  double val;
  val = par[1];
  return val;
}


// Calcolo della funzione da minimizzare (chi-quadro)
double xfcn(int npar, double *par){

  int      i;
  double   chi,chid, f=0;
 
  for (i=0; i < ndat; i++){
    chi   = (y[i] - xfun(x[i],npar,par));
    chid  = pow(ey[i],2) + pow(xder(x[i],npar,par)*ex[i],2);
    f    += chi*chi/chid;  
  }
  return f;

}

// Routine per disegnare la funzione
void plotfun(double fun(double, int, double *), int npar, double *par,
             double xmin, double xmax){

#define npts 100  

  double xx[npts],yy[npts];
  int i;

  for(i=0;i<npts;i++){
    xx[i] = i/((double)npts)*(xmax-xmin)+xmin;
    yy[i] = fun(xx[i],npar, par);
  }
  R_Graph(npts,xx,yy,"C");

}

int main(){

#define npar 2

  double par[npar]={0.0,1.0},outpar[npar],err[npar];
  double chiq;
  double xmin=0.2,xmax=0.5,ymin=0.9,ymax=1.8;


  // Minimizzazione
  R_MinuitSimpl(xfcn,npar,par,outpar,err,&chiq);  

  // Grafico
  R_Init();                 // Apre la finestra grafica
  R_SetGrid(1);             // Opzione griglia sugli assi
  R_DrawFrame(xmin,xmax,ymin,ymax);   // Disegna gli assi
  R_AxisTitles("Xaxis","Yaxis");      // Scrive i nome degli assi
  R_GraphErrors(ndat,x,y,ex,ey,"P");  // Disegna punti con errore
  plotfun(xfun,npar,outpar,x[0],x[ndat-1]); // Disegna la funzione fittata
  R_End();                 // Chiude la finestra

  return 0;

}


















